package Test2;

import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import kodkod.ast.*;
import kodkod.ast.operator.*;
import kodkod.instance.*;
import kodkod.engine.*;
import kodkod.engine.satlab.SATFactory;
import kodkod.engine.config.Options;

/* 
  ==================================================
    kodkod formula: 
  ==================================================
    no (this/Client & this/GW) && 
    no ((this/Client + this/GW) & this/Repos) && 
    no (this/IPdomain & this/NDNdomain) && 
    no ((this/IPdomain + this/NDNdomain) & this/MFdomain) && 
    no (this/Up & this/Down) && 
    no (this/PrimaryState & this/SecondaryState) && 
    (all return_this: this/Client | 
      #(return_this . this/Node.domains) = 1) && 
    (all return_this: this/GW | 
      one (return_this . this/GW.statetype) && 
      (return_this . this/GW.statetype) in (this/PrimaryState + 
      this/SecondaryState)) && 
    (this/GW.statetype . univ) in this/GW && 
    (all return_this: this/GW | 
      #(return_this . this/Node.domains) = 2 && 
      (all return_d1: this/IPdomain + this/NDNdomain + this/MFdomain, return_d2: 
       this/IPdomain + this/NDNdomain + this/MFdomain | 
        !(no (return_d1 & return_d2) && 
          ((return_d1 in this/IPdomain && 
            return_d2 in this/IPdomain) || 
           (return_d1 in this/NDNdomain && 
            return_d2 in this/NDNdomain) || 
           (return_d1 in this/MFdomain && 
            return_d2 in this/MFdomain))))) && 
    (all return_this: this/Repos | 
      #(return_this . this/Node.domains) = 1) && 
    (all return_this: this/Client + this/GW + this/Repos | 
      (return_this . this/Node.domains) in (this/IPdomain + this/NDNdomain + 
      this/MFdomain)) && 
    (this/Node.domains . univ) in (this/Client + this/GW + this/Repos) && 
    (all return_this: this/Client + this/GW + this/Repos | 
      one (return_this . this/Node.status1) && 
      (return_this . this/Node.status1) in (this/Up + this/Down)) && 
    (this/Node.status1 . univ) in (this/Client + this/GW + this/Repos) && 
    (all return_this: this/Client + this/GW + this/Repos | 
      one (return_this . this/Node.status2) && 
      (return_this . this/Node.status2) in (this/Up + this/Down)) && 
    (this/Node.status2 . univ) in (this/Client + this/GW + this/Repos) && 
    (all return_this: this/Route | 
      one (return_this . this/Route.initiator) && 
      (return_this . this/Route.initiator) in (this/Client + this/GW + 
      this/Repos)) && 
    (this/Route.initiator . univ) in this/Route && 
    (all return_this: this/Route | 
      one (return_this . this/Route.acceptor) && 
      (return_this . this/Route.acceptor) in (this/Client + this/GW + this/Repos
      )) && 
    (this/Route.acceptor . univ) in this/Route && 
    (all return_this: this/Route | 
      one (return_this . this/Route.domain) && 
      (return_this . this/Route.domain) in (this/IPdomain + this/NDNdomain + 
      this/MFdomain)) && 
    (this/Route.domain . univ) in this/Route && 
    (all return_this: this/Route | 
      !((return_this . this/Route.initiator) = (return_this . 
        this/Route.acceptor)) && 
      (return_this . this/Route.domain) in ((return_this . this/Route.initiator) . 
      this/Node.domains) && 
      (return_this . this/Route.domain) in ((return_this . this/Route.acceptor) . 
      this/Node.domains)) && 
    (all return_this: this/RouteR | 
      one (return_this . this/RouteR.initiator) && 
      (return_this . this/RouteR.initiator) in (this/Client + this/GW + 
      this/Repos)) && 
    (this/RouteR.initiator . univ) in this/RouteR && 
    (all return_this: this/RouteR | 
      one (return_this . this/RouteR.acceptor) && 
      (return_this . this/RouteR.acceptor) in (this/Client + this/GW + 
      this/Repos)) && 
    (this/RouteR.acceptor . univ) in this/RouteR && 
    (all return_this: this/RouteR | 
      one (return_this . this/RouteR.domain) && 
      (return_this . this/RouteR.domain) in (this/IPdomain + this/NDNdomain + 
      this/MFdomain)) && 
    (this/RouteR.domain . univ) in this/RouteR && 
    (all return_this: this/RouteR | 
      !((return_this . this/RouteR.initiator) = (return_this . 
        this/RouteR.acceptor)) && 
      (return_this . this/RouteR.domain) in ((return_this . 
      this/RouteR.initiator) . this/Node.domains) && 
      (return_this . this/RouteR.domain) in ((return_this . this/RouteR.acceptor
      ) . this/Node.domains)) && 
    (this/Connections . (this/Connections -> this/Connections.connected)) in (
    this/Route -> this/Route) && 
    (this/Connections . (this/Connections -> this/Connections.connectedR)) in (
    this/RouteR -> this/RouteR) && 
    (all return_r1: this/Route, return_r2: this/Route, return_c: 
     this/Connections | 
      (return_r1 -> return_r2) in (return_c . (this/Connections -> 
      this/Connections.connected)) <=> 
      ((return_r1 . this/Route.acceptor) = (return_r2 . this/Route.initiator) && 
       ((return_r1 . this/Route.initiator) . this/Node.status1) in this/Up && 
       ((return_r2 . this/Route.initiator) . this/Node.status1) in this/Up)) && 
    (all return_r1: this/RouteR, return_r2: this/RouteR, return_c: 
     this/Connections | 
      (return_r1 -> return_r2) in (return_c . (this/Connections -> 
      this/Connections.connectedR)) <=> 
      ((return_r1 . this/RouteR.acceptor) = (return_r2 . this/RouteR.initiator) && 
       ((return_r1 . this/RouteR.initiator) . this/Node.status1) in this/Up && 
       (!((return_r1 . this/RouteR.domain) in this/NDNdomain || 
          (return_r2 . this/RouteR.domain) in this/NDNdomain) || 
        ((return_r1 . this/RouteR.acceptor) . this/GW.statetype) in 
        this/PrimaryState) && 
       ((return_r2 . this/RouteR.initiator) . this/Node.status1) in this/Up)) && 
    #(this/Repos) = 1 && 
    #(this/Client) = 1 && 
    #(this/Connections) = 1 && 
    (this/Client . this/Node.status1) in this/Up && 
    (this/Repos . this/Node.status1) in this/Up && 
    (this/Client . this/Node.status2) in this/Up && 
    (this/Repos . this/Node.status2) in this/Up && 
    (all return_r: this/Repos, return_c: this/Client | 
      all return_d: this/IPdomain + this/NDNdomain + this/MFdomain | 
       !(return_d in (return_r . this/Node.domains) && 
         return_d in (return_c . this/Node.domains))) && 
    (all return_d: this/IPdomain + this/NDNdomain + this/MFdomain | 
      some return_gw: this/GW | 
       return_d in (return_gw . this/Node.domains)) && 
    #(this/Route) = 2 && 
    #(this/RouteR) = 2 && 
    #(this/IPdomain + this/NDNdomain + this/MFdomain) = 2 && 
    #(this/GW) = 2 && 
    #(this/Up) = 1 && 
    #(this/Down) = 1 && 
    #(this/PrimaryState) = 1 && 
    #(this/SecondaryState) = 1 && 
    (all return_r: this/Route | 
      !((return_r . this/Route.acceptor) in this/Client && 
        (return_r . this/Route.initiator) in this/Repos)) && 
    (all return_r: this/Route | 
      !((return_r . this/Route.acceptor) in this/Client || 
        (return_r . this/Route.initiator) in this/Repos || 
        ((return_r . this/Route.acceptor) in this/GW && 
         (return_r . this/Route.initiator) in this/GW))) && 
    (all return_gw: this/GW | 
      (return_gw . this/Node.status1) in this/Up) && 
    (all return_r: this/Route | 
      !((return_r . this/Route.initiator) in this/Client && 
        ((return_r . this/Route.acceptor) . this/Node.status2) in this/Up)) && 
    one {return_gw: this/GW | (some return_r1: this/Route, return_r2: this/Route | 
      no (return_r1 & return_r2) && 
      (return_r1 . this/Route.initiator) in this/Client && 
      (return_r2 . this/Route.initiator) = return_gw && 
      (return_r2 . this/Route.acceptor) in this/Repos && 
      (return_r1 . this/Route.acceptor) = return_gw) && 
    (return_gw . this/Node.status2) in this/Down && 
    (return_gw . this/GW.statetype) in this/PrimaryState} && 
    (all return_r: this/RouteR | 
      !((return_r . this/RouteR.acceptor) in this/Repos || 
        (return_r . this/RouteR.initiator) in this/Client || 
        ((return_r . this/RouteR.acceptor) in this/GW && 
         (return_r . this/RouteR.initiator) in this/GW))) && 
    one {return_gw: this/GW | (some return_r1: this/RouteR, return_r2: 
     this/RouteR | 
      no (return_r1 & return_r2) && 
      (return_r1 . this/RouteR.initiator) in this/Repos && 
      (return_r2 . this/RouteR.initiator) = return_gw && 
      (return_r2 . this/RouteR.acceptor) in this/Client && 
      (return_r1 . this/RouteR.acceptor) = return_gw) && 
    (return_gw . this/Node.status2) in this/Up && 
    (return_gw . this/GW.statetype) in this/SecondaryState} && 
    !((some reach_r1: this/Route, reach_r2: this/Route | 
        no (reach_r1 & reach_r2) && 
        (reach_r1 -> reach_r2) in ^this/Connections.connected && 
        (reach_r2 . this/Route.acceptor) in this/Repos && 
        (reach_r1 . this/Route.initiator) in this/Client) && 
      (some return_r1: this/RouteR, return_r2: this/RouteR | 
        no (return_r1 & return_r2) && 
        (return_r1 -> return_r2) in ^this/Connections.connectedR && 
        (return_r2 . this/RouteR.acceptor) in this/Client && 
        (return_r1 . this/RouteR.initiator) in this/Repos)) && 
    Int/next = Int/next && 
    seq/Int = seq/Int && 
    String = String && 
    this/Client = this/Client && 
    this/GW = this/GW && 
    this/Repos = this/Repos && 
    this/IPdomain = this/IPdomain && 
    this/NDNdomain = this/NDNdomain && 
    this/MFdomain = this/MFdomain && 
    this/Up = this/Up && 
    this/Down = this/Down && 
    this/PrimaryState = this/PrimaryState && 
    this/SecondaryState = this/SecondaryState && 
    this/Route = this/Route && 
    this/RouteR = this/RouteR && 
    this/Connections = this/Connections && 
    this/Node.domains = this/Node.domains && 
    this/Node.status1 = this/Node.status1 && 
    this/Node.status2 = this/Node.status2 && 
    this/GW.statetype = this/GW.statetype && 
    this/Route.initiator = this/Route.initiator && 
    this/Route.acceptor = this/Route.acceptor && 
    this/Route.domain = this/Route.domain && 
    this/RouteR.initiator = this/RouteR.initiator && 
    this/RouteR.acceptor = this/RouteR.acceptor && 
    this/RouteR.domain = this/RouteR.domain && 
    this/Connections.connected = this/Connections.connected && 
    this/Connections.connectedR = this/Connections.connectedR
  ==================================================
*/
public final class Test_solveall1 {

public static void main(String[] args) throws Exception {

Relation x0 = Relation.nary("Int/next", 2);
Relation x1 = Relation.unary("seq/Int");
Relation x2 = Relation.unary("String");
Relation x3 = Relation.unary("this/Client");
Relation x4 = Relation.unary("this/GW");
Relation x5 = Relation.unary("this/Repos");
Relation x6 = Relation.unary("this/IPdomain");
Relation x7 = Relation.unary("this/NDNdomain");
Relation x8 = Relation.unary("this/MFdomain");
Relation x9 = Relation.unary("this/Up");
Relation x10 = Relation.unary("this/Down");
Relation x11 = Relation.unary("this/PrimaryState");
Relation x12 = Relation.unary("this/SecondaryState");
Relation x13 = Relation.unary("this/Route");
Relation x14 = Relation.unary("this/RouteR");
Relation x15 = Relation.unary("this/Connections");
Relation x16 = Relation.nary("this/Node.domains", 2);
Relation x17 = Relation.nary("this/Node.status1", 2);
Relation x18 = Relation.nary("this/Node.status2", 2);
Relation x19 = Relation.nary("this/GW.statetype", 2);
Relation x20 = Relation.nary("this/Route.initiator", 2);
Relation x21 = Relation.nary("this/Route.acceptor", 2);
Relation x22 = Relation.nary("this/Route.domain", 2);
Relation x23 = Relation.nary("this/RouteR.initiator", 2);
Relation x24 = Relation.nary("this/RouteR.acceptor", 2);
Relation x25 = Relation.nary("this/RouteR.domain", 2);
Relation x26 = Relation.nary("this/Connections.connected", 2);
Relation x27 = Relation.nary("this/Connections.connectedR", 2);

List<String> atomlist = Arrays.asList(
 "Connections$0", "Domain$0", "Domain$1", "Domain$2", "Domain$3",
 "Node$0", "Node$1", "Node$2", "Node$3", "Route$0", "Route$1",
 "Route$2", "Route$3", "RouteR$0", "RouteR$1", "RouteR$2", "RouteR$3",
 "StateType$0", "StateType$1", "StateType$2", "StateType$3", "Status$0", "Status$1",
 "Status$2", "Status$3"
);

Universe universe = new Universe(atomlist);
TupleFactory factory = universe.factory();
Bounds bounds = new Bounds(universe);

TupleSet x0_upper = factory.noneOf(2);
bounds.boundExactly(x0, x0_upper);

TupleSet x1_upper = factory.noneOf(1);
bounds.boundExactly(x1, x1_upper);

TupleSet x2_upper = factory.noneOf(1);
bounds.boundExactly(x2, x2_upper);

TupleSet x3_upper = factory.noneOf(1);
x3_upper.add(factory.tuple("Node$0"));
x3_upper.add(factory.tuple("Node$1"));
x3_upper.add(factory.tuple("Node$2"));
x3_upper.add(factory.tuple("Node$3"));
bounds.bound(x3, x3_upper);

TupleSet x4_upper = factory.noneOf(1);
x4_upper.add(factory.tuple("Node$0"));
x4_upper.add(factory.tuple("Node$1"));
x4_upper.add(factory.tuple("Node$2"));
x4_upper.add(factory.tuple("Node$3"));
bounds.bound(x4, x4_upper);

TupleSet x5_upper = factory.noneOf(1);
x5_upper.add(factory.tuple("Node$0"));
x5_upper.add(factory.tuple("Node$1"));
x5_upper.add(factory.tuple("Node$2"));
x5_upper.add(factory.tuple("Node$3"));
bounds.bound(x5, x5_upper);

TupleSet x6_upper = factory.noneOf(1);
x6_upper.add(factory.tuple("Domain$0"));
x6_upper.add(factory.tuple("Domain$1"));
x6_upper.add(factory.tuple("Domain$2"));
x6_upper.add(factory.tuple("Domain$3"));
bounds.bound(x6, x6_upper);

TupleSet x7_upper = factory.noneOf(1);
x7_upper.add(factory.tuple("Domain$0"));
x7_upper.add(factory.tuple("Domain$1"));
x7_upper.add(factory.tuple("Domain$2"));
x7_upper.add(factory.tuple("Domain$3"));
bounds.bound(x7, x7_upper);

TupleSet x8_upper = factory.noneOf(1);
x8_upper.add(factory.tuple("Domain$0"));
x8_upper.add(factory.tuple("Domain$1"));
x8_upper.add(factory.tuple("Domain$2"));
x8_upper.add(factory.tuple("Domain$3"));
bounds.bound(x8, x8_upper);

TupleSet x9_upper = factory.noneOf(1);
x9_upper.add(factory.tuple("Status$0"));
x9_upper.add(factory.tuple("Status$1"));
x9_upper.add(factory.tuple("Status$2"));
x9_upper.add(factory.tuple("Status$3"));
bounds.bound(x9, x9_upper);

TupleSet x10_upper = factory.noneOf(1);
x10_upper.add(factory.tuple("Status$0"));
x10_upper.add(factory.tuple("Status$1"));
x10_upper.add(factory.tuple("Status$2"));
x10_upper.add(factory.tuple("Status$3"));
bounds.bound(x10, x10_upper);

TupleSet x11_upper = factory.noneOf(1);
x11_upper.add(factory.tuple("StateType$0"));
x11_upper.add(factory.tuple("StateType$1"));
x11_upper.add(factory.tuple("StateType$2"));
x11_upper.add(factory.tuple("StateType$3"));
bounds.bound(x11, x11_upper);

TupleSet x12_upper = factory.noneOf(1);
x12_upper.add(factory.tuple("StateType$0"));
x12_upper.add(factory.tuple("StateType$1"));
x12_upper.add(factory.tuple("StateType$2"));
x12_upper.add(factory.tuple("StateType$3"));
bounds.bound(x12, x12_upper);

TupleSet x13_upper = factory.noneOf(1);
x13_upper.add(factory.tuple("Route$0"));
x13_upper.add(factory.tuple("Route$1"));
x13_upper.add(factory.tuple("Route$2"));
x13_upper.add(factory.tuple("Route$3"));
bounds.bound(x13, x13_upper);

TupleSet x14_upper = factory.noneOf(1);
x14_upper.add(factory.tuple("RouteR$0"));
x14_upper.add(factory.tuple("RouteR$1"));
x14_upper.add(factory.tuple("RouteR$2"));
x14_upper.add(factory.tuple("RouteR$3"));
bounds.bound(x14, x14_upper);

TupleSet x15_upper = factory.noneOf(1);
x15_upper.add(factory.tuple("Connections$0"));
bounds.boundExactly(x15, x15_upper);

TupleSet x16_upper = factory.noneOf(2);
x16_upper.add(factory.tuple("Node$0").product(factory.tuple("Domain$0")));
x16_upper.add(factory.tuple("Node$0").product(factory.tuple("Domain$1")));
x16_upper.add(factory.tuple("Node$0").product(factory.tuple("Domain$2")));
x16_upper.add(factory.tuple("Node$0").product(factory.tuple("Domain$3")));
x16_upper.add(factory.tuple("Node$1").product(factory.tuple("Domain$0")));
x16_upper.add(factory.tuple("Node$1").product(factory.tuple("Domain$1")));
x16_upper.add(factory.tuple("Node$1").product(factory.tuple("Domain$2")));
x16_upper.add(factory.tuple("Node$1").product(factory.tuple("Domain$3")));
x16_upper.add(factory.tuple("Node$2").product(factory.tuple("Domain$0")));
x16_upper.add(factory.tuple("Node$2").product(factory.tuple("Domain$1")));
x16_upper.add(factory.tuple("Node$2").product(factory.tuple("Domain$2")));
x16_upper.add(factory.tuple("Node$2").product(factory.tuple("Domain$3")));
x16_upper.add(factory.tuple("Node$3").product(factory.tuple("Domain$0")));
x16_upper.add(factory.tuple("Node$3").product(factory.tuple("Domain$1")));
x16_upper.add(factory.tuple("Node$3").product(factory.tuple("Domain$2")));
x16_upper.add(factory.tuple("Node$3").product(factory.tuple("Domain$3")));
bounds.bound(x16, x16_upper);

TupleSet x17_upper = factory.noneOf(2);
x17_upper.add(factory.tuple("Node$0").product(factory.tuple("Status$0")));
x17_upper.add(factory.tuple("Node$0").product(factory.tuple("Status$1")));
x17_upper.add(factory.tuple("Node$0").product(factory.tuple("Status$2")));
x17_upper.add(factory.tuple("Node$0").product(factory.tuple("Status$3")));
x17_upper.add(factory.tuple("Node$1").product(factory.tuple("Status$0")));
x17_upper.add(factory.tuple("Node$1").product(factory.tuple("Status$1")));
x17_upper.add(factory.tuple("Node$1").product(factory.tuple("Status$2")));
x17_upper.add(factory.tuple("Node$1").product(factory.tuple("Status$3")));
x17_upper.add(factory.tuple("Node$2").product(factory.tuple("Status$0")));
x17_upper.add(factory.tuple("Node$2").product(factory.tuple("Status$1")));
x17_upper.add(factory.tuple("Node$2").product(factory.tuple("Status$2")));
x17_upper.add(factory.tuple("Node$2").product(factory.tuple("Status$3")));
x17_upper.add(factory.tuple("Node$3").product(factory.tuple("Status$0")));
x17_upper.add(factory.tuple("Node$3").product(factory.tuple("Status$1")));
x17_upper.add(factory.tuple("Node$3").product(factory.tuple("Status$2")));
x17_upper.add(factory.tuple("Node$3").product(factory.tuple("Status$3")));
bounds.bound(x17, x17_upper);

TupleSet x18_upper = factory.noneOf(2);
x18_upper.add(factory.tuple("Node$0").product(factory.tuple("Status$0")));
x18_upper.add(factory.tuple("Node$0").product(factory.tuple("Status$1")));
x18_upper.add(factory.tuple("Node$0").product(factory.tuple("Status$2")));
x18_upper.add(factory.tuple("Node$0").product(factory.tuple("Status$3")));
x18_upper.add(factory.tuple("Node$1").product(factory.tuple("Status$0")));
x18_upper.add(factory.tuple("Node$1").product(factory.tuple("Status$1")));
x18_upper.add(factory.tuple("Node$1").product(factory.tuple("Status$2")));
x18_upper.add(factory.tuple("Node$1").product(factory.tuple("Status$3")));
x18_upper.add(factory.tuple("Node$2").product(factory.tuple("Status$0")));
x18_upper.add(factory.tuple("Node$2").product(factory.tuple("Status$1")));
x18_upper.add(factory.tuple("Node$2").product(factory.tuple("Status$2")));
x18_upper.add(factory.tuple("Node$2").product(factory.tuple("Status$3")));
x18_upper.add(factory.tuple("Node$3").product(factory.tuple("Status$0")));
x18_upper.add(factory.tuple("Node$3").product(factory.tuple("Status$1")));
x18_upper.add(factory.tuple("Node$3").product(factory.tuple("Status$2")));
x18_upper.add(factory.tuple("Node$3").product(factory.tuple("Status$3")));
bounds.bound(x18, x18_upper);

TupleSet x19_upper = factory.noneOf(2);
x19_upper.add(factory.tuple("Node$0").product(factory.tuple("StateType$0")));
x19_upper.add(factory.tuple("Node$0").product(factory.tuple("StateType$1")));
x19_upper.add(factory.tuple("Node$0").product(factory.tuple("StateType$2")));
x19_upper.add(factory.tuple("Node$0").product(factory.tuple("StateType$3")));
x19_upper.add(factory.tuple("Node$1").product(factory.tuple("StateType$0")));
x19_upper.add(factory.tuple("Node$1").product(factory.tuple("StateType$1")));
x19_upper.add(factory.tuple("Node$1").product(factory.tuple("StateType$2")));
x19_upper.add(factory.tuple("Node$1").product(factory.tuple("StateType$3")));
x19_upper.add(factory.tuple("Node$2").product(factory.tuple("StateType$0")));
x19_upper.add(factory.tuple("Node$2").product(factory.tuple("StateType$1")));
x19_upper.add(factory.tuple("Node$2").product(factory.tuple("StateType$2")));
x19_upper.add(factory.tuple("Node$2").product(factory.tuple("StateType$3")));
x19_upper.add(factory.tuple("Node$3").product(factory.tuple("StateType$0")));
x19_upper.add(factory.tuple("Node$3").product(factory.tuple("StateType$1")));
x19_upper.add(factory.tuple("Node$3").product(factory.tuple("StateType$2")));
x19_upper.add(factory.tuple("Node$3").product(factory.tuple("StateType$3")));
bounds.bound(x19, x19_upper);

TupleSet x20_upper = factory.noneOf(2);
x20_upper.add(factory.tuple("Route$0").product(factory.tuple("Node$0")));
x20_upper.add(factory.tuple("Route$0").product(factory.tuple("Node$1")));
x20_upper.add(factory.tuple("Route$0").product(factory.tuple("Node$2")));
x20_upper.add(factory.tuple("Route$0").product(factory.tuple("Node$3")));
x20_upper.add(factory.tuple("Route$1").product(factory.tuple("Node$0")));
x20_upper.add(factory.tuple("Route$1").product(factory.tuple("Node$1")));
x20_upper.add(factory.tuple("Route$1").product(factory.tuple("Node$2")));
x20_upper.add(factory.tuple("Route$1").product(factory.tuple("Node$3")));
x20_upper.add(factory.tuple("Route$2").product(factory.tuple("Node$0")));
x20_upper.add(factory.tuple("Route$2").product(factory.tuple("Node$1")));
x20_upper.add(factory.tuple("Route$2").product(factory.tuple("Node$2")));
x20_upper.add(factory.tuple("Route$2").product(factory.tuple("Node$3")));
x20_upper.add(factory.tuple("Route$3").product(factory.tuple("Node$0")));
x20_upper.add(factory.tuple("Route$3").product(factory.tuple("Node$1")));
x20_upper.add(factory.tuple("Route$3").product(factory.tuple("Node$2")));
x20_upper.add(factory.tuple("Route$3").product(factory.tuple("Node$3")));
bounds.bound(x20, x20_upper);

TupleSet x21_upper = factory.noneOf(2);
x21_upper.add(factory.tuple("Route$0").product(factory.tuple("Node$0")));
x21_upper.add(factory.tuple("Route$0").product(factory.tuple("Node$1")));
x21_upper.add(factory.tuple("Route$0").product(factory.tuple("Node$2")));
x21_upper.add(factory.tuple("Route$0").product(factory.tuple("Node$3")));
x21_upper.add(factory.tuple("Route$1").product(factory.tuple("Node$0")));
x21_upper.add(factory.tuple("Route$1").product(factory.tuple("Node$1")));
x21_upper.add(factory.tuple("Route$1").product(factory.tuple("Node$2")));
x21_upper.add(factory.tuple("Route$1").product(factory.tuple("Node$3")));
x21_upper.add(factory.tuple("Route$2").product(factory.tuple("Node$0")));
x21_upper.add(factory.tuple("Route$2").product(factory.tuple("Node$1")));
x21_upper.add(factory.tuple("Route$2").product(factory.tuple("Node$2")));
x21_upper.add(factory.tuple("Route$2").product(factory.tuple("Node$3")));
x21_upper.add(factory.tuple("Route$3").product(factory.tuple("Node$0")));
x21_upper.add(factory.tuple("Route$3").product(factory.tuple("Node$1")));
x21_upper.add(factory.tuple("Route$3").product(factory.tuple("Node$2")));
x21_upper.add(factory.tuple("Route$3").product(factory.tuple("Node$3")));
bounds.bound(x21, x21_upper);

TupleSet x22_upper = factory.noneOf(2);
x22_upper.add(factory.tuple("Route$0").product(factory.tuple("Domain$0")));
x22_upper.add(factory.tuple("Route$0").product(factory.tuple("Domain$1")));
x22_upper.add(factory.tuple("Route$0").product(factory.tuple("Domain$2")));
x22_upper.add(factory.tuple("Route$0").product(factory.tuple("Domain$3")));
x22_upper.add(factory.tuple("Route$1").product(factory.tuple("Domain$0")));
x22_upper.add(factory.tuple("Route$1").product(factory.tuple("Domain$1")));
x22_upper.add(factory.tuple("Route$1").product(factory.tuple("Domain$2")));
x22_upper.add(factory.tuple("Route$1").product(factory.tuple("Domain$3")));
x22_upper.add(factory.tuple("Route$2").product(factory.tuple("Domain$0")));
x22_upper.add(factory.tuple("Route$2").product(factory.tuple("Domain$1")));
x22_upper.add(factory.tuple("Route$2").product(factory.tuple("Domain$2")));
x22_upper.add(factory.tuple("Route$2").product(factory.tuple("Domain$3")));
x22_upper.add(factory.tuple("Route$3").product(factory.tuple("Domain$0")));
x22_upper.add(factory.tuple("Route$3").product(factory.tuple("Domain$1")));
x22_upper.add(factory.tuple("Route$3").product(factory.tuple("Domain$2")));
x22_upper.add(factory.tuple("Route$3").product(factory.tuple("Domain$3")));
bounds.bound(x22, x22_upper);

TupleSet x23_upper = factory.noneOf(2);
x23_upper.add(factory.tuple("RouteR$0").product(factory.tuple("Node$0")));
x23_upper.add(factory.tuple("RouteR$0").product(factory.tuple("Node$1")));
x23_upper.add(factory.tuple("RouteR$0").product(factory.tuple("Node$2")));
x23_upper.add(factory.tuple("RouteR$0").product(factory.tuple("Node$3")));
x23_upper.add(factory.tuple("RouteR$1").product(factory.tuple("Node$0")));
x23_upper.add(factory.tuple("RouteR$1").product(factory.tuple("Node$1")));
x23_upper.add(factory.tuple("RouteR$1").product(factory.tuple("Node$2")));
x23_upper.add(factory.tuple("RouteR$1").product(factory.tuple("Node$3")));
x23_upper.add(factory.tuple("RouteR$2").product(factory.tuple("Node$0")));
x23_upper.add(factory.tuple("RouteR$2").product(factory.tuple("Node$1")));
x23_upper.add(factory.tuple("RouteR$2").product(factory.tuple("Node$2")));
x23_upper.add(factory.tuple("RouteR$2").product(factory.tuple("Node$3")));
x23_upper.add(factory.tuple("RouteR$3").product(factory.tuple("Node$0")));
x23_upper.add(factory.tuple("RouteR$3").product(factory.tuple("Node$1")));
x23_upper.add(factory.tuple("RouteR$3").product(factory.tuple("Node$2")));
x23_upper.add(factory.tuple("RouteR$3").product(factory.tuple("Node$3")));
bounds.bound(x23, x23_upper);

TupleSet x24_upper = factory.noneOf(2);
x24_upper.add(factory.tuple("RouteR$0").product(factory.tuple("Node$0")));
x24_upper.add(factory.tuple("RouteR$0").product(factory.tuple("Node$1")));
x24_upper.add(factory.tuple("RouteR$0").product(factory.tuple("Node$2")));
x24_upper.add(factory.tuple("RouteR$0").product(factory.tuple("Node$3")));
x24_upper.add(factory.tuple("RouteR$1").product(factory.tuple("Node$0")));
x24_upper.add(factory.tuple("RouteR$1").product(factory.tuple("Node$1")));
x24_upper.add(factory.tuple("RouteR$1").product(factory.tuple("Node$2")));
x24_upper.add(factory.tuple("RouteR$1").product(factory.tuple("Node$3")));
x24_upper.add(factory.tuple("RouteR$2").product(factory.tuple("Node$0")));
x24_upper.add(factory.tuple("RouteR$2").product(factory.tuple("Node$1")));
x24_upper.add(factory.tuple("RouteR$2").product(factory.tuple("Node$2")));
x24_upper.add(factory.tuple("RouteR$2").product(factory.tuple("Node$3")));
x24_upper.add(factory.tuple("RouteR$3").product(factory.tuple("Node$0")));
x24_upper.add(factory.tuple("RouteR$3").product(factory.tuple("Node$1")));
x24_upper.add(factory.tuple("RouteR$3").product(factory.tuple("Node$2")));
x24_upper.add(factory.tuple("RouteR$3").product(factory.tuple("Node$3")));
bounds.bound(x24, x24_upper);

TupleSet x25_upper = factory.noneOf(2);
x25_upper.add(factory.tuple("RouteR$0").product(factory.tuple("Domain$0")));
x25_upper.add(factory.tuple("RouteR$0").product(factory.tuple("Domain$1")));
x25_upper.add(factory.tuple("RouteR$0").product(factory.tuple("Domain$2")));
x25_upper.add(factory.tuple("RouteR$0").product(factory.tuple("Domain$3")));
x25_upper.add(factory.tuple("RouteR$1").product(factory.tuple("Domain$0")));
x25_upper.add(factory.tuple("RouteR$1").product(factory.tuple("Domain$1")));
x25_upper.add(factory.tuple("RouteR$1").product(factory.tuple("Domain$2")));
x25_upper.add(factory.tuple("RouteR$1").product(factory.tuple("Domain$3")));
x25_upper.add(factory.tuple("RouteR$2").product(factory.tuple("Domain$0")));
x25_upper.add(factory.tuple("RouteR$2").product(factory.tuple("Domain$1")));
x25_upper.add(factory.tuple("RouteR$2").product(factory.tuple("Domain$2")));
x25_upper.add(factory.tuple("RouteR$2").product(factory.tuple("Domain$3")));
x25_upper.add(factory.tuple("RouteR$3").product(factory.tuple("Domain$0")));
x25_upper.add(factory.tuple("RouteR$3").product(factory.tuple("Domain$1")));
x25_upper.add(factory.tuple("RouteR$3").product(factory.tuple("Domain$2")));
x25_upper.add(factory.tuple("RouteR$3").product(factory.tuple("Domain$3")));
bounds.bound(x25, x25_upper);

TupleSet x26_upper = factory.noneOf(2);
x26_upper.add(factory.tuple("Route$0").product(factory.tuple("Route$0")));
x26_upper.add(factory.tuple("Route$0").product(factory.tuple("Route$1")));
x26_upper.add(factory.tuple("Route$0").product(factory.tuple("Route$2")));
x26_upper.add(factory.tuple("Route$0").product(factory.tuple("Route$3")));
x26_upper.add(factory.tuple("Route$1").product(factory.tuple("Route$0")));
x26_upper.add(factory.tuple("Route$1").product(factory.tuple("Route$1")));
x26_upper.add(factory.tuple("Route$1").product(factory.tuple("Route$2")));
x26_upper.add(factory.tuple("Route$1").product(factory.tuple("Route$3")));
x26_upper.add(factory.tuple("Route$2").product(factory.tuple("Route$0")));
x26_upper.add(factory.tuple("Route$2").product(factory.tuple("Route$1")));
x26_upper.add(factory.tuple("Route$2").product(factory.tuple("Route$2")));
x26_upper.add(factory.tuple("Route$2").product(factory.tuple("Route$3")));
x26_upper.add(factory.tuple("Route$3").product(factory.tuple("Route$0")));
x26_upper.add(factory.tuple("Route$3").product(factory.tuple("Route$1")));
x26_upper.add(factory.tuple("Route$3").product(factory.tuple("Route$2")));
x26_upper.add(factory.tuple("Route$3").product(factory.tuple("Route$3")));
bounds.bound(x26, x26_upper);

TupleSet x27_upper = factory.noneOf(2);
x27_upper.add(factory.tuple("RouteR$0").product(factory.tuple("RouteR$0")));
x27_upper.add(factory.tuple("RouteR$0").product(factory.tuple("RouteR$1")));
x27_upper.add(factory.tuple("RouteR$0").product(factory.tuple("RouteR$2")));
x27_upper.add(factory.tuple("RouteR$0").product(factory.tuple("RouteR$3")));
x27_upper.add(factory.tuple("RouteR$1").product(factory.tuple("RouteR$0")));
x27_upper.add(factory.tuple("RouteR$1").product(factory.tuple("RouteR$1")));
x27_upper.add(factory.tuple("RouteR$1").product(factory.tuple("RouteR$2")));
x27_upper.add(factory.tuple("RouteR$1").product(factory.tuple("RouteR$3")));
x27_upper.add(factory.tuple("RouteR$2").product(factory.tuple("RouteR$0")));
x27_upper.add(factory.tuple("RouteR$2").product(factory.tuple("RouteR$1")));
x27_upper.add(factory.tuple("RouteR$2").product(factory.tuple("RouteR$2")));
x27_upper.add(factory.tuple("RouteR$2").product(factory.tuple("RouteR$3")));
x27_upper.add(factory.tuple("RouteR$3").product(factory.tuple("RouteR$0")));
x27_upper.add(factory.tuple("RouteR$3").product(factory.tuple("RouteR$1")));
x27_upper.add(factory.tuple("RouteR$3").product(factory.tuple("RouteR$2")));
x27_upper.add(factory.tuple("RouteR$3").product(factory.tuple("RouteR$3")));
bounds.bound(x27, x27_upper);


Expression x30=x3.intersection(x4);
Formula x29=x30.no();
Expression x33=x3.union(x4);
Expression x32=x33.intersection(x5);
Formula x31=x32.no();
Expression x35=x6.intersection(x7);
Formula x34=x35.no();
Expression x38=x6.union(x7);
Expression x37=x38.intersection(x8);
Formula x36=x37.no();
Expression x40=x9.intersection(x10);
Formula x39=x40.no();
Expression x42=x11.intersection(x12);
Formula x41=x42.no();
Variable x45=Variable.unary("return_this");
Decls x44=x45.oneOf(x3);
Expression x48=x45.join(x16);
IntExpression x47=x48.count();
IntExpression x49=IntConstant.constant(1);
Formula x46=x47.eq(x49);
Formula x43=x46.forAll(x44);
Variable x52=Variable.unary("return_this");
Decls x51=x52.oneOf(x4);
Expression x55=x52.join(x19);
Formula x54=x55.one();
Expression x57=x11.union(x12);
Formula x56=x55.in(x57);
Formula x53=x54.and(x56);
Formula x50=x53.forAll(x51);
Expression x59=x19.join(Expression.UNIV);
Formula x58=x59.in(x4);
Variable x63=Variable.unary("return_this");
Decls x62=x63.oneOf(x4);
Expression x67=x63.join(x16);
IntExpression x66=x67.count();
IntExpression x68=IntConstant.constant(2);
Formula x65=x66.eq(x68);
Variable x72=Variable.unary("return_d1");
Expression x73=x38.union(x8);
Decls x71=x72.oneOf(x73);
Variable x75=Variable.unary("return_d2");
Decls x74=x75.oneOf(x73);
Decls x70=x71.and(x74);
Expression x79=x72.intersection(x75);
Formula x78=x79.no();
Formula x83=x72.in(x6);
Formula x84=x75.in(x6);
Formula x82=x83.and(x84);
Formula x86=x72.in(x7);
Formula x87=x75.in(x7);
Formula x85=x86.and(x87);
Formula x81=x82.or(x85);
Formula x89=x72.in(x8);
Formula x90=x75.in(x8);
Formula x88=x89.and(x90);
Formula x80=x81.or(x88);
Formula x77=x78.and(x80);
Formula x76=x77.not();
Formula x69=x76.forAll(x70);
Formula x64=x65.and(x69);
Formula x61=x64.forAll(x62);
Variable x93=Variable.unary("return_this");
Decls x92=x93.oneOf(x5);
Expression x96=x93.join(x16);
IntExpression x95=x96.count();
IntExpression x97=IntConstant.constant(1);
Formula x94=x95.eq(x97);
Formula x91=x94.forAll(x92);
Variable x100=Variable.unary("return_this");
Expression x101=x33.union(x5);
Decls x99=x100.oneOf(x101);
Expression x103=x100.join(x16);
Formula x102=x103.in(x73);
Formula x98=x102.forAll(x99);
Expression x105=x16.join(Expression.UNIV);
Formula x104=x105.in(x101);
Variable x108=Variable.unary("return_this");
Decls x107=x108.oneOf(x101);
Expression x111=x108.join(x17);
Formula x110=x111.one();
Expression x113=x9.union(x10);
Formula x112=x111.in(x113);
Formula x109=x110.and(x112);
Formula x106=x109.forAll(x107);
Expression x115=x17.join(Expression.UNIV);
Formula x114=x115.in(x101);
Variable x118=Variable.unary("return_this");
Decls x117=x118.oneOf(x101);
Expression x121=x118.join(x18);
Formula x120=x121.one();
Formula x122=x121.in(x113);
Formula x119=x120.and(x122);
Formula x116=x119.forAll(x117);
Expression x124=x18.join(Expression.UNIV);
Formula x123=x124.in(x101);
Variable x127=Variable.unary("return_this");
Decls x126=x127.oneOf(x13);
Expression x130=x127.join(x20);
Formula x129=x130.one();
Formula x131=x130.in(x101);
Formula x128=x129.and(x131);
Formula x125=x128.forAll(x126);
Expression x133=x20.join(Expression.UNIV);
Formula x132=x133.in(x13);
Variable x136=Variable.unary("return_this");
Decls x135=x136.oneOf(x13);
Expression x139=x136.join(x21);
Formula x138=x139.one();
Formula x140=x139.in(x101);
Formula x137=x138.and(x140);
Formula x134=x137.forAll(x135);
Expression x142=x21.join(Expression.UNIV);
Formula x141=x142.in(x13);
Variable x145=Variable.unary("return_this");
Decls x144=x145.oneOf(x13);
Expression x148=x145.join(x22);
Formula x147=x148.one();
Formula x149=x148.in(x73);
Formula x146=x147.and(x149);
Formula x143=x146.forAll(x144);
Expression x151=x22.join(Expression.UNIV);
Formula x150=x151.in(x13);
Variable x154=Variable.unary("return_this");
Decls x153=x154.oneOf(x13);
Expression x159=x154.join(x20);
Expression x160=x154.join(x21);
Formula x158=x159.eq(x160);
Formula x157=x158.not();
Expression x162=x154.join(x22);
Expression x164=x154.join(x20);
Expression x163=x164.join(x16);
Formula x161=x162.in(x163);
Formula x156=x157.and(x161);
Expression x166=x154.join(x22);
Expression x168=x154.join(x21);
Expression x167=x168.join(x16);
Formula x165=x166.in(x167);
Formula x155=x156.and(x165);
Formula x152=x155.forAll(x153);
Variable x171=Variable.unary("return_this");
Decls x170=x171.oneOf(x14);
Expression x174=x171.join(x23);
Formula x173=x174.one();
Formula x175=x174.in(x101);
Formula x172=x173.and(x175);
Formula x169=x172.forAll(x170);
Expression x177=x23.join(Expression.UNIV);
Formula x176=x177.in(x14);
Variable x180=Variable.unary("return_this");
Decls x179=x180.oneOf(x14);
Expression x183=x180.join(x24);
Formula x182=x183.one();
Formula x184=x183.in(x101);
Formula x181=x182.and(x184);
Formula x178=x181.forAll(x179);
Expression x186=x24.join(Expression.UNIV);
Formula x185=x186.in(x14);
Variable x189=Variable.unary("return_this");
Decls x188=x189.oneOf(x14);
Expression x192=x189.join(x25);
Formula x191=x192.one();
Formula x193=x192.in(x73);
Formula x190=x191.and(x193);
Formula x187=x190.forAll(x188);
Expression x195=x25.join(Expression.UNIV);
Formula x194=x195.in(x14);
Variable x198=Variable.unary("return_this");
Decls x197=x198.oneOf(x14);
Expression x203=x198.join(x23);
Expression x204=x198.join(x24);
Formula x202=x203.eq(x204);
Formula x201=x202.not();
Expression x206=x198.join(x25);
Expression x208=x198.join(x23);
Expression x207=x208.join(x16);
Formula x205=x206.in(x207);
Formula x200=x201.and(x205);
Expression x210=x198.join(x25);
Expression x212=x198.join(x24);
Expression x211=x212.join(x16);
Formula x209=x210.in(x211);
Formula x199=x200.and(x209);
Formula x196=x199.forAll(x197);
Expression x215=x15.product(x26);
Expression x214=x15.join(x215);
Expression x216=x13.product(x13);
Formula x213=x214.in(x216);
Expression x219=x15.product(x27);
Expression x218=x15.join(x219);
Expression x220=x14.product(x14);
Formula x217=x218.in(x220);
Variable x224=Variable.unary("return_r1");
Decls x223=x224.oneOf(x13);
Variable x226=Variable.unary("return_r2");
Decls x225=x226.oneOf(x13);
Variable x228=Variable.unary("return_c");
Decls x227=x228.oneOf(x15);
Decls x222=x223.and(x225).and(x227);
Expression x231=x224.product(x226);
Expression x232=x228.join(x215);
Formula x230=x231.in(x232);
Expression x236=x224.join(x21);
Expression x237=x226.join(x20);
Formula x235=x236.eq(x237);
Expression x240=x224.join(x20);
Expression x239=x240.join(x17);
Formula x238=x239.in(x9);
Formula x234=x235.and(x238);
Expression x243=x226.join(x20);
Expression x242=x243.join(x17);
Formula x241=x242.in(x9);
Formula x233=x234.and(x241);
Formula x229=x230.iff(x233);
Formula x221=x229.forAll(x222);
Variable x247=Variable.unary("return_r1");
Decls x246=x247.oneOf(x14);
Variable x249=Variable.unary("return_r2");
Decls x248=x249.oneOf(x14);
Variable x251=Variable.unary("return_c");
Decls x250=x251.oneOf(x15);
Decls x245=x246.and(x248).and(x250);
Expression x254=x247.product(x249);
Expression x255=x251.join(x219);
Formula x253=x254.in(x255);
Expression x259=x247.join(x24);
Expression x260=x249.join(x23);
Formula x258=x259.eq(x260);
Expression x264=x247.join(x23);
Expression x263=x264.join(x17);
Formula x262=x263.in(x9);
Expression x269=x247.join(x25);
Formula x268=x269.in(x7);
Expression x271=x249.join(x25);
Formula x270=x271.in(x7);
Formula x267=x268.or(x270);
Formula x266=x267.not();
Expression x274=x247.join(x24);
Expression x273=x274.join(x19);
Formula x272=x273.in(x11);
Formula x265=x266.or(x272);
Formula x261=x262.and(x265);
Formula x257=x258.and(x261);
Expression x277=x249.join(x23);
Expression x276=x277.join(x17);
Formula x275=x276.in(x9);
Formula x256=x257.and(x275);
Formula x252=x253.iff(x256);
Formula x244=x252.forAll(x245);
IntExpression x279=x5.count();
IntExpression x280=IntConstant.constant(1);
Formula x278=x279.eq(x280);
IntExpression x282=x3.count();
IntExpression x283=IntConstant.constant(1);
Formula x281=x282.eq(x283);
IntExpression x285=x15.count();
IntExpression x286=IntConstant.constant(1);
Formula x284=x285.eq(x286);
Expression x288=x3.join(x17);
Formula x287=x288.in(x9);
Expression x290=x5.join(x17);
Formula x289=x290.in(x9);
Expression x292=x3.join(x18);
Formula x291=x292.in(x9);
Expression x294=x5.join(x18);
Formula x293=x294.in(x9);
Variable x298=Variable.unary("return_r");
Decls x297=x298.oneOf(x5);
Variable x300=Variable.unary("return_c");
Decls x299=x300.oneOf(x3);
Decls x296=x297.and(x299);
Variable x303=Variable.unary("return_d");
Decls x302=x303.oneOf(x73);
Expression x307=x298.join(x16);
Formula x306=x303.in(x307);
Expression x309=x300.join(x16);
Formula x308=x303.in(x309);
Formula x305=x306.and(x308);
Formula x304=x305.not();
Formula x301=x304.forAll(x302);
Formula x295=x301.forAll(x296);
Variable x312=Variable.unary("return_d");
Decls x311=x312.oneOf(x73);
Variable x315=Variable.unary("return_gw");
Decls x314=x315.oneOf(x4);
Expression x317=x315.join(x16);
Formula x316=x312.in(x317);
Formula x313=x316.forSome(x314);
Formula x310=x313.forAll(x311);
IntExpression x319=x13.count();
IntExpression x320=IntConstant.constant(2);
Formula x318=x319.eq(x320);
IntExpression x322=x14.count();
IntExpression x323=IntConstant.constant(2);
Formula x321=x322.eq(x323);
IntExpression x325=x73.count();
IntExpression x326=IntConstant.constant(2);
Formula x324=x325.eq(x326);
IntExpression x328=x4.count();
IntExpression x329=IntConstant.constant(2);
Formula x327=x328.eq(x329);
IntExpression x331=x9.count();
IntExpression x332=IntConstant.constant(1);
Formula x330=x331.eq(x332);
IntExpression x334=x10.count();
IntExpression x335=IntConstant.constant(1);
Formula x333=x334.eq(x335);
IntExpression x337=x11.count();
IntExpression x338=IntConstant.constant(1);
Formula x336=x337.eq(x338);
IntExpression x340=x12.count();
IntExpression x341=IntConstant.constant(1);
Formula x339=x340.eq(x341);
Variable x344=Variable.unary("return_r");
Decls x343=x344.oneOf(x13);
Expression x348=x344.join(x21);
Formula x347=x348.in(x3);
Expression x350=x344.join(x20);
Formula x349=x350.in(x5);
Formula x346=x347.and(x349);
Formula x345=x346.not();
Formula x342=x345.forAll(x343);
Variable x353=Variable.unary("return_r");
Decls x352=x353.oneOf(x13);
Expression x358=x353.join(x21);
Formula x357=x358.in(x3);
Expression x360=x353.join(x20);
Formula x359=x360.in(x5);
Formula x356=x357.or(x359);
Expression x363=x353.join(x21);
Formula x362=x363.in(x4);
Expression x365=x353.join(x20);
Formula x364=x365.in(x4);
Formula x361=x362.and(x364);
Formula x355=x356.or(x361);
Formula x354=x355.not();
Formula x351=x354.forAll(x352);
Variable x368=Variable.unary("return_gw");
Decls x367=x368.oneOf(x4);
Expression x370=x368.join(x17);
Formula x369=x370.in(x9);
Formula x366=x369.forAll(x367);
Variable x373=Variable.unary("return_r");
Decls x372=x373.oneOf(x13);
Expression x377=x373.join(x20);
Formula x376=x377.in(x3);
Expression x380=x373.join(x21);
Expression x379=x380.join(x18);
Formula x378=x379.in(x9);
Formula x375=x376.and(x378);
Formula x374=x375.not();
Formula x371=x374.forAll(x372);
Variable x384=Variable.unary("return_gw");
Decls x383=x384.oneOf(x4);
Variable x390=Variable.unary("return_r1");
Decls x389=x390.oneOf(x13);
Variable x392=Variable.unary("return_r2");
Decls x391=x392.oneOf(x13);
Decls x388=x389.and(x391);
Expression x396=x390.intersection(x392);
Formula x395=x396.no();
Expression x400=x390.join(x20);
Formula x399=x400.in(x3);
Expression x402=x392.join(x20);
Formula x401=x402.eq(x384);
Formula x398=x399.and(x401);
Expression x404=x392.join(x21);
Formula x403=x404.in(x5);
Formula x397=x398.and(x403);
Formula x394=x395.and(x397);
Expression x406=x390.join(x21);
Formula x405=x406.eq(x384);
Formula x393=x394.and(x405);
Formula x387=x393.forSome(x388);
Expression x408=x384.join(x18);
Formula x407=x408.in(x10);
Formula x386=x387.and(x407);
Expression x410=x384.join(x19);
Formula x409=x410.in(x11);
Formula x385=x386.and(x409);
Expression x382=x385.comprehension(x383);
Formula x381=x382.one();
Variable x413=Variable.unary("return_r");
Decls x412=x413.oneOf(x14);
Expression x418=x413.join(x24);
Formula x417=x418.in(x5);
Expression x420=x413.join(x23);
Formula x419=x420.in(x3);
Formula x416=x417.or(x419);
Expression x423=x413.join(x24);
Formula x422=x423.in(x4);
Expression x425=x413.join(x23);
Formula x424=x425.in(x4);
Formula x421=x422.and(x424);
Formula x415=x416.or(x421);
Formula x414=x415.not();
Formula x411=x414.forAll(x412);
Variable x429=Variable.unary("return_gw");
Decls x428=x429.oneOf(x4);
Variable x435=Variable.unary("return_r1");
Decls x434=x435.oneOf(x14);
Variable x437=Variable.unary("return_r2");
Decls x436=x437.oneOf(x14);
Decls x433=x434.and(x436);
Expression x441=x435.intersection(x437);
Formula x440=x441.no();
Expression x445=x435.join(x23);
Formula x444=x445.in(x5);
Expression x447=x437.join(x23);
Formula x446=x447.eq(x429);
Formula x443=x444.and(x446);
Expression x449=x437.join(x24);
Formula x448=x449.in(x3);
Formula x442=x443.and(x448);
Formula x439=x440.and(x442);
Expression x451=x435.join(x24);
Formula x450=x451.eq(x429);
Formula x438=x439.and(x450);
Formula x432=x438.forSome(x433);
Expression x453=x429.join(x18);
Formula x452=x453.in(x9);
Formula x431=x432.and(x452);
Expression x455=x429.join(x19);
Formula x454=x455.in(x12);
Formula x430=x431.and(x454);
Expression x427=x430.comprehension(x428);
Formula x426=x427.one();
Variable x461=Variable.unary("reach_r1");
Decls x460=x461.oneOf(x13);
Variable x463=Variable.unary("reach_r2");
Decls x462=x463.oneOf(x13);
Decls x459=x460.and(x462);
Expression x467=x461.intersection(x463);
Formula x466=x467.no();
Expression x470=x461.product(x463);
Expression x471=x26.closure();
Formula x469=x470.in(x471);
Expression x473=x463.join(x21);
Formula x472=x473.in(x5);
Formula x468=x469.and(x472);
Formula x465=x466.and(x468);
Expression x475=x461.join(x20);
Formula x474=x475.in(x3);
Formula x464=x465.and(x474);
Formula x458=x464.forSome(x459);
Variable x479=Variable.unary("return_r1");
Decls x478=x479.oneOf(x14);
Variable x481=Variable.unary("return_r2");
Decls x480=x481.oneOf(x14);
Decls x477=x478.and(x480);
Expression x485=x479.intersection(x481);
Formula x484=x485.no();
Expression x488=x479.product(x481);
Expression x489=x27.closure();
Formula x487=x488.in(x489);
Expression x491=x481.join(x24);
Formula x490=x491.in(x3);
Formula x486=x487.and(x490);
Formula x483=x484.and(x486);
Expression x493=x479.join(x23);
Formula x492=x493.in(x5);
Formula x482=x483.and(x492);
Formula x476=x482.forSome(x477);
Formula x457=x458.and(x476);
Formula x456=x457.not();
Formula x494=x0.eq(x0);
Formula x495=x1.eq(x1);
Formula x496=x2.eq(x2);
Formula x497=x3.eq(x3);
Formula x498=x4.eq(x4);
Formula x499=x5.eq(x5);
Formula x500=x6.eq(x6);
Formula x501=x7.eq(x7);
Formula x502=x8.eq(x8);
Formula x503=x9.eq(x9);
Formula x504=x10.eq(x10);
Formula x505=x11.eq(x11);
Formula x506=x12.eq(x12);
Formula x507=x13.eq(x13);
Formula x508=x14.eq(x14);
Formula x509=x15.eq(x15);
Formula x510=x16.eq(x16);
Formula x511=x17.eq(x17);
Formula x512=x18.eq(x18);
Formula x513=x19.eq(x19);
Formula x514=x20.eq(x20);
Formula x515=x21.eq(x21);
Formula x516=x22.eq(x22);
Formula x517=x23.eq(x23);
Formula x518=x24.eq(x24);
Formula x519=x25.eq(x25);
Formula x520=x26.eq(x26);
Formula x521=x27.eq(x27);
Formula x28=Formula.compose(FormulaOperator.AND, x29, x31, x34, x36, x39, x41, x43, x50, x58, x61, x91, x98, x104, x106, x114, x116, x123, x125, x132, x134, x141, x143, x150, x152, x169, x176, x178, x185, x187, x194, x196, x213, x217, x221, x244, x278, x281, x284, x287, x289, x291, x293, x295, x310, x318, x321, x324, x327, x330, x333, x336, x339, x342, x351, x366, x371, x381, x411, x426, x456, x494, x495, x496, x497, x498, x499, x500, x501, x502, x503, x504, x505, x506, x507, x508, x509, x510, x511, x512, x513, x514, x515, x516, x517, x518, x519, x520, x521);

Solver solver = new Solver();
solver.options().setSolver(SATFactory.DefaultSAT4J);
solver.options().setBitwidth(1);
solver.options().setIntEncoding(Options.IntEncoding.TWOSCOMPLEMENT);
solver.options().setSymmetryBreaking(20);
solver.options().setSkolemDepth(0);
System.out.println("Solving...");
System.out.flush();

long start = System.currentTimeMillis();  
Iterator <Solution> iter =  solver.solveAll(x28, bounds);
int count = 0;
//count = Iterators.size(iter);
while(iter.hasNext()){
    count ++;
    if(count % 1000 == 0)
        System.out.println(count+"\t"+(System.currentTimeMillis() - start)+" ms");
//    Solution sol = iter.next();
//    System.out.println(sol.toString());
//    Instance solIns = sol.instance();
//    System.out.println(solIns.tuples(x19));
    iter.next();
}
//Solution sol = solver.solve(x28,bounds);
System.out.println(count+"\t"+(System.currentTimeMillis() - start)+" ms");

}}
