abstract sig Node{domains: set Domain, status1, status2: Status}
sig Client extends Node{}{#domains=1}
sig GW extends Node{statetype: StateType}
	{#domains=2 && 
	(no disj d1,d2: Domain| (d1 in IPdomain && d2 in IPdomain) || 
	(d1 in NDNdomain && d2 in NDNdomain) || (d1 in MFdomain && d2 in MFdomain))}
sig Repos extends Node{}{#domains=1}

abstract sig Domain{}
sig IPdomain extends Domain{}
sig NDNdomain extends Domain{}
sig MFdomain extends Domain{}

abstract sig Status{}
sig Up extends Status{}
sig Down extends Status{}

abstract sig StateType{}
sig PrimaryState extends StateType{}
sig SecondaryState extends StateType{}

abstract sig Route{initiator, acceptor: Node, domain: one Domain}
	{initiator!=acceptor && domain in initiator.domains && domain in acceptor.domains}

abstract sig RouteR{initiator, acceptor: Node, domain: one Domain}
	{initiator!=acceptor && domain in initiator.domains && domain in acceptor.domains}

one sig Connections{connected: Route -> Route, connectedR: RouteR -> RouteR}

fact connected{
--forward routes
	all r1,r2: Route, c:Connections| (r1->r2) in c.connected iff
		r1.acceptor = r2.initiator && r1.initiator.status1 in Up && r2.initiator.status1 in Up 
--reverse routes
	all r1,r2: RouteR, c:Connections| (r1->r2) in c.connectedR iff
		r1.acceptor = r2.initiator && r1.initiator.status2 in Up && r2.initiator.status2 in Up 
		&& ( (r1.domain in NDNdomain || r2.domain in NDNdomain) => r1.acceptor.statetype in PrimaryState)
}

fact{
	#Repos=1 #Client=1 #Connections=1
	Client.status1 in Up && Repos.status1 in Up
	Client.status2 in Up && Repos.status2 in Up
	all r:Repos, c:Client| no d:Domain| d in r.domains && d in c.domains
	all d:Domain| some gw:GW| d in gw.domains
}

pred reach{
	some disj r1,r2:Route| (r1->r2) in ^(Connections.connected) && r1.initiator in Client && r2.acceptor in Repos
}

run reach for 2 Route, 4 RouteR, 4 Node, 1 Connections, 2 Domain, 2 Status, 2 StateType

assert reach{
	reach
}
check reach for 2 Route, 4 RouteR, 4 Node, 1 Connections, 2 Domain, 2 Status, 2 StateType

pred return{
	reach && (
	some disj r1,r2:RouteR| (r1->r2) in ^(Connections.connectedR) && r1.initiator in Repos && r2.acceptor in Client	
	)
}

run return for 2 Route, 4 RouteR, 4 Node, 1 Connections, 2 Domain, 2 Status, 2 StateType

assert return {
	return
}
check return for 2 Route, 4 RouteR, 4 Node, 1 Connections, 2 Domain, 2 Status, 2 StateType


//Test Cases
fact{
	#Route=2 #RouteR=4 #Domain=2 #GW=2
	#Up=1 #Down=1 
	#PrimaryState=1 #SecondaryState=1
	no r:Route| (r.acceptor in Client) && (r.initiator in Repos)
	no r:Route| (r.acceptor in Client) || (r.initiator in Repos) || (r.acceptor in GW && r.initiator in GW)
	all gw:GW| gw.status1 in Up
	//no r:Route | r.initiator in Client && r.acceptor.status2 in Up
	one gw:GW | (some disj r1,r2: Route| 
		r1.initiator in Client && r1.acceptor=gw && r2.initiator=gw && r2.acceptor in Repos)
		//&& gw.status2 in Down 
		&& gw.statetype in PrimaryState
	//
	no r:RouteR| (r.acceptor in Repos) || (r.initiator in Client) || (r.acceptor in GW && r.initiator in GW)
	one gw:GW | (some disj r1,r2: RouteR| 
		r1.initiator in Repos && r1.acceptor=gw && r2.initiator=gw && r2.acceptor in Client)
		//&& gw.status2 in Up 
		&& gw.statetype in SecondaryState
	//#NDNdomain=1
}
